Ticket #1450 (closed defect: fixed)

Opened 9 years ago

Last modified 9 years ago

FISH: timestamps don't show correctly

Reported by: slavazanko Owned by: angel_il
Priority: major Milestone:
Component: mc-vfs Version: master
Keywords: Cc: bonoba@…, isee@…, imdagger@…, lly, zaytsev
Blocked By: #2242 Blocking:
Branch state: Votes for changeset:

Description

Test case:
1) Make FISH-connect to some host;
2) sort files by modification time;
3) will see older files (from previous year) as new files

For check, connect to same host and enter in command line:

ls -lt

Thanks for bugreport to Alexander Glyzov.

Attachments

fish_vfs_date.patch (701 bytes) - added by IMDagger 9 years ago.
Fix for FISHFS files modification date

Change History

comment:1 Changed 9 years ago by smart

  • Cc isee@… added

Changed 9 years ago by IMDagger

Fix for FISHFS files modification date

comment:2 Changed 9 years ago by IMDagger

  • Cc imdagger@… added

Because first part of FISH-ls script is Perl script. But localtime function returns dates like:
Fri Sep 18 10:40:28 2009
But in utilvfs.c is written: So both year and time is not allowed. fish_vfs_date.patch fixed write format of date.

comment:3 Changed 9 years ago by slavazanko

  • Owner set to slavazanko
  • Status changed from new to accepted

comment:4 Changed 9 years ago by slavazanko

  • severity changed from no branch to on review

Created branch 1450_fish_timestamps

Changesets:

Review, please.

comment:5 Changed 9 years ago by iNode

  • Votes for changeset set to iNode

comment:6 Changed 9 years ago by slavazanko

  • Milestone changed from 4.7 to 4.7.0

comment:7 Changed 9 years ago by andrew_b

  • Votes for changeset changed from iNode to iNode andrew_b
  • severity changed from on review to approved

comment:8 Changed 9 years ago by slavazanko

  • Status changed from accepted to testing
  • Votes for changeset changed from iNode andrew_b to commited-master
  • Resolution set to fixed
  • severity changed from approved to merged

comment:9 Changed 9 years ago by slavazanko

  • Status changed from testing to closed

comment:10 Changed 9 years ago by angel_il

  • Status changed from closed to reopened
  • Votes for changeset commited-master deleted
  • Resolution fixed deleted
  • severity changed from merged to no branch

commit: 4fc08a729e1aefe22f1965e2536a88bdfcc0cf62 broke the FISH under my WL-500gP device (oleg's firmware)

all catalogs and files has ' n3' postfix, like this:

│/dev n3                  │ 
│/home n3                 │ 
│/lib n3                  │ 
│/mnt n3                  │ 
│/opt n3                  │ 
│/proc n3                 │ 
│/sbin n3                 │ 
│/tmp n3                  │ 
│/usr n3                  │ 
│/www n3                  │ 
│!etc                     │ 
│*linuxrc n3              │ 
│!var                     │ 
│ .version n3               

comment:11 Changed 9 years ago by angel_il

/bin/ls -lan /
-rw-r--r--    1 0        0              10 Feb 28  2009 .version
drwxr-xr-x    1 0        0             360 Feb 28  2009 bin
drwxr-xr-x    1 0        0               0 Jan  1  1970 dev
lrwxrwxrwx    1 0        0               7 Feb 28  2009 etc -> tmp/etc
drwxr-xr-x    1 0        0               0 Feb 28  2009 home
drwxr-xr-x    1 0        0             164 Feb 28  2009 lib
-rwxr-xr-x    1 0        0            2032 Feb 28  2009 linuxrc
drwxr-xr-x    1 0        0               0 Feb 28  2009 mnt
drwxr-xr-x   17 0        0            4096 Mar 15  2009 opt
dr-xr-xr-x   34 0        0               0 Jan  1  2000 proc
drwxr-xr-x    1 0        0             522 Feb 28  2009 sbin
drwxrwxrwx    1 0        0               0 Jan  1  2000 tmp
drwxr-xr-x    1 0        0              71 Feb 28  2009 usr
lrwxrwxrwx    1 0        0               7 Feb 28  2009 var -> tmp/var
drwxr-xr-x    1 0        0            2229 Feb 28  2009 www
ls -lan /
total 15
drwxr-xr-x  1 0 0  360 2009-02-28 21:03 bin
drwxr-xr-x  1 0 0    0 1970-01-01 03:00 dev
lrwxrwxrwx  1 0 0    7 2009-02-28 21:04 etc -> tmp/etc
drwxr-xr-x  1 0 0    0 2009-02-28 21:04 home
drwxr-xr-x  1 0 0  164 2009-02-28 21:04 lib
-rwxr-xr-x  1 0 0 2032 2009-02-28 21:03 linuxrc
drwxr-xr-x  1 0 0    0 2009-02-28 21:04 mnt
drwxr-xr-x 17 0 0 4096 2009-03-15 00:09 opt
dr-xr-xr-x 34 0 0    0 2000-01-01 03:00 proc
drwxr-xr-x  1 0 0  522 2009-02-28 21:03 sbin
drwxrwxrwx  1 0 0    0 2000-01-01 03:00 tmp
drwxr-xr-x  1 0 0   71 2009-02-28 21:04 usr
lrwxrwxrwx  1 0 0    7 2009-02-28 21:04 var -> tmp/var
-rw-r--r--  1 0 0   10 2009-02-28 21:03 .version
drwxr-xr-x  1 0 0 2229 2009-02-28 21:03 www

comment:12 Changed 9 years ago by slavazanko

  • severity changed from no branch to on review

Created branch 1450_fish_dir_load_fix

Initial changeset: a3ee5860bbf78cd4f65dd12eebba46397800b02d

Review

comment:13 Changed 9 years ago by andrew_b

  • Votes for changeset set to andrew_b

comment:14 Changed 9 years ago by angel_il

  • Votes for changeset changed from andrew_b to andrew_b angel_il
  • severity changed from on review to approved

comment:15 Changed 9 years ago by slavazanko

  • Status changed from reopened to closed
  • Votes for changeset changed from andrew_b angel_il to commited-master
  • Resolution set to fixed
  • severity changed from approved to merged

comment:16 Changed 9 years ago by lly

  • Status changed from closed to reopened
  • Version changed from 4.7.0-pre1 to 4.7.0.5
  • Resolution fixed deleted

Unfortunately, both 4.7.0.5 & 4.7.2 mc versions has broken FISH on embedded device with busybox 1.16.1 shell - all catalog & files looks like this:

┌<─ /#sh:admin@192.168.1.100/tmp ─.[^]>┐
│'n     Name      │ Size  │Modify time │
│/..              │UP--DIR│May  6 19:32│
│/."              │    240│Jan  1 03:00│
│/.."             │    170│May  5 00:00│
│/etc"            │    460│Jan  1 03:00│
│/local"          │    140│Jan  1  2000│
│/mnt"            │     40│Jan  1 03:00│
│/ppp"            │    100│Jan  1 03:00│
│/var"            │    180│Jan  1 03:00│
│ filter_rules"   │   1310│Jan  1 03:00│
│ nat_rules"      │    290│Jan  1 03:00│
│ resolv.conf"    │      0│Jan  1 03:00│
│ syslog.log"     │   5121│Jan  1 03:07│

i.e. with extra quote after name. Native ls output on device itself:

$ ls -lan /tmp
drwxrwxrwt    7 0        0              240 Jan  1 03:00 .
drwxr-xr-x   14 0        0              170 May  5  2010 ..
drwxr-xr-x    4 0        0              460 Jan  1 03:00 etc
-rw-r--r--    1 0        0             1310 Jan  1 03:00 filter_rules
drwxr-xr-x    5 0        0              140 Jan  1  2000 local
drwxr-xr-x    2 0        0               40 Jan  1 03:00 mnt
-rw-r--r--    1 0        0              290 Jan  1 03:00 nat_rules
drwxr-xr-x    2 0        0              100 Jan  1 03:00 ppp
-rw-r--r--    1 0        0                0 Jan  1 03:00 resolv.conf
-rw-r--r--    1 0        0             5954 Jan  1 03:15 syslog.log
drwxr-xr-x    9 0        0              180 Jan  1 03:00 var

comment:17 Changed 9 years ago by lly

Sorry, forgot to mention that bug is observed on 4.7.0.1,4.7.0.2,4.7.0.3,4.7.0.4 too and absent in 4.7.0-pre4.

comment:18 Changed 9 years ago by angel_il

branch: 1450_fish_fix
changeset: 0bbab2338ea02b29ffa2ee9655a6ea19634d527c

comment:19 Changed 9 years ago by angel_il

  • Owner changed from slavazanko to angel_il
  • Cc lly added
  • Status changed from reopened to accepted

comment:20 Changed 9 years ago by angel_il

  • Votes for changeset committed-master deleted
  • severity changed from merged to on review

comment:21 Changed 9 years ago by andrew_b

  • Keywords FISH removed
  • Votes for changeset set to andrew_b

comment:22 Changed 9 years ago by slavazanko

  • Votes for changeset changed from andrew_b to andrew_b slavazanko
  • severity changed from on review to approved

comment:23 Changed 9 years ago by angel_il

  • Votes for changeset andrew_b slavazanko deleted

comment:24 Changed 9 years ago by andrew_b

  • severity changed from approved to on rework

comment:25 Changed 9 years ago by andrew_b

  • Milestone changed from 4.7.0 to 4.7

comment:26 Changed 9 years ago by lly

Clarification - problem described in comment 16, appeared with recent busybox versions which supports "ls -Qlan" only.

comment:27 Changed 9 years ago by zaytsev

  • Cc zaytsev added
  • Version changed from 4.7.0.5 to master

comment:28 Changed 9 years ago by zaytsev

  • Blocked By 2242 added

comment:29 Changed 9 years ago by lly

in 4.7.3 release my problem (see comment 16) was gone.

comment:30 Changed 9 years ago by zaytsev

  • Status changed from accepted to testing
  • Resolution set to fixed

comment:31 Changed 9 years ago by zaytsev

  • Status changed from testing to closed
  • severity changed from on rework to no branch
  • Milestone 4.7 deleted
Note: See TracTickets for help on using tickets.